/*
	scroll.c  -  ւXN[o[Cu
	Ver.0.1 (2006/07/15)
	Copyright (c) 2006 Akkiesoft.
*/

#include <guigui00.h>
#include "scroll.h"

struct SCROLLBAR *scroll_init(
	struct SCROLLBAR *b, int mode, struct LIB_WINDOW *win, struct LIB_GRAPHBOX *gbox,
	int wpx, int wpy, int px, int py, int sx, int sy, int skip)
/*
	: XN[o[iȉAo[ƌĂԁj̏{p[c`
	:
		b        == o[
		mode     == o[̃[hi0=c/1=j
		win      == EBhE
		gbox     == OtBbN{bNX
		wpx, wpy == EBhEWnł̃o[̈ʒu
		px, py   == OtBbN{bNXWnł̃o[̈ʒu
		sx, sy   == o[̑傫
					mode=0: sxo[̖{^̈ӂ̃TCYɂȂ܂
					mode=1: syo[̖{^̈ӂ̃TCYɂȂ܂
		skip     == OtBbN{bNX̉
*/
{
	if (b == AUTO_MALLOC) {
		b = malloc(sizeof (struct SCROLLBAR));
	}
	b->mode = mode;
	b->win  = win;
	b->gbox = gbox;
	b->wpx  = wpx;
	b->wpy  = wpy;
	b->px   = px;
	b->py   = py;
	b->sx   = sx;
	b->sy   = sy;
	b->skip = skip;

	b->bgpx = px;
	b->bgpy = py;
	b->bgsx = sx;
	b->bgsy = sy;
	if (mode) {
		// mode == 1
		b->btnsize = sy;
		b->bgpx += b->btnsize;
		b->bgsx -= b->btnsize*2;
	} else {
		// mode == 0
		b->btnsize = sx;
		b->bgpy += b->btnsize;
		b->bgsy -= b->btnsize*2;
	}

	/* {` */
	if (b->mode) {
		scroll_drawbtn(b, b->px          , b->py, b->btnsize, b->btnsize, 2);
	 	scroll_drawbtn(b, b->bgpx+b->bgsx, b->py, b->btnsize, b->btnsize, 3);
	} else {
		scroll_drawbtn(b, b->px, b->py          , b->btnsize, b->btnsize, 0);
	 	scroll_drawbtn(b, b->px, b->bgpy+b->bgsy, b->btnsize, b->btnsize, 1);
	}
	scroll_drawbg(b);
	scroll_flush(b);

	return b;
}

void scroll_drawbg(struct SCROLLBAR *b)
/*
	: XN[o[̔wi`
			scroll.ĉ݂Ŏgp
	:
		b == `悷XN[o[
*/
{
	int i, j;
	unsigned char *p_gbox = LIB_GBOX_BUF(b->gbox);

	for (j = 0; j < b->bgsy; j++) {
		for (i = 0; i < b->bgsx; i++)
			p_gbox[(b->bgpy+j)*b->skip + b->bgpx+i] = ((i+j) & 1) * 7 + 8;
	}

	return;
}

void scroll_drawbtn(struct SCROLLBAR *b, int px, int py, int sx, int sy, int mode)
/*
	: {^`imode0`3̂Ƃ͖`悷j
			scroll.ĉ݂Ŏgp
	:
		b      == `悷XN[o[
		px, py == {^`悷n_W
		sx, sy == {^̑傫
		mode   == 0, 1, 2, 3ꂼ㉺EɑΉ
*/
{
	int i, j, mx, my;
	unsigned char *p_gbox = LIB_GBOX_BUF(b->gbox);

	for (j = 0; j < sy; j++) {
		for (i = 0; i < sx; i++)
			p_gbox[(py+j)*b->skip + px+i] = 8;
	}

	lib_drawline0(0x8000, b->gbox, 15, px     , py     , px+sx-1, py     );
	lib_drawline0(0x8000, b->gbox, 15, px     , py     , px     , py+sy-1);
	lib_drawline0(0x8000, b->gbox,  0, px     , py+sy-1, px+sx-1, py+sy-1);
	lib_drawline0(0x8000, b->gbox,  0, px+sx-1, py     , px+sx-1, py+sy-1);
	lib_drawline0(0x8000, b->gbox,  7, px+1   , py+sy-2, px+sx-2, py+sy-2);
	lib_drawline0(0x8000, b->gbox,  7, px+sx-2, py+1   , px+sx-2, py+sy-2);

	if (mode < 4) {
		// mode0`3̂ƂA`
		mx = px + sx / 2;	/* {bNX̒S߂iEj */
		my = py + sy / 2;	/*                       i㉺j */

		for (i = 0; i < 4; i++) {
			if (mode < 2)
				lib_drawline0(0x8000, b->gbox, 0, mx-1-(mode*3-i), my-2+i, mx-1+(mode*3-i), my-2+i);
		//			lib_drawline0(0, b->gbox, 0, mx-1-i, my-2+i, mx-1+i, my-2+i);
		//			lib_drawline0(0, b->gbox, 0, mx-1-(3-i), my-2+i, mx-1+(3-i), my-2+i);
			else 
				lib_drawline0(0x8000, b->gbox, 0, mx-2+i, my-1-((mode-2)*3-i), mx-2+i, my-1+((mode-2)*3-i));
		//			lib_drawline0(0, b->gbox, 0, mx-2+i, my-1-i, mx-2+i, my-1+i);
		//			lib_drawline0(0, b->gbox, 0, mx+1-i, my-1-i, mx+1-i, my-1+i);
		}
	}

	return;
}

void scroll_setbar(struct SCROLLBAR *b, int x1, int x2, int bp)
/*
	: o[̂܂ޕ`
	:
		b    == `悷XN[o[
		x1   == ݕ\Ă镝
		x2   == XN[ł镝
		bp   == ݂̃XN[ʒu̍W̏c(modełǂ炩)
*/
{
	int i, l, size, pos;

	scroll_drawbg(b);

	// o[̑傫
	if (b->mode)
		i = b->sx - b->btnsize*2;
	else
		i = b->sy - b->btnsize*2;
	size = x1 * i / x2;
	if (i <= size) {
		scroll_flush(b);
		return;
	}
	if (size < 5) {
		size = 5;
		x1 = 5*x2/i;
	}

	// o[̈ʒu
	pos = bp * size / x1;

	// Ō̃XN[ł܂肪ol߂悤ɂ
	l = (bp+1) * size / x1;
	if (i <= l + size)
		pos = i - size;

	if (b->mode)
		scroll_drawbtn(b, b->btnsize + pos, b->py, size, b->sy, 4);
	else
		scroll_drawbtn(b, b->px, b->btnsize + pos, b->sx, size, 4);

	scroll_flush(b);
	return;
}

void scroll_kado(struct SCROLLBAR *t, struct SCROLLBAR *y)
/*
	: cɃo[uƂ̊p𖄂߂Ă񂺂悤i܂j
	:
		t == cXN[o[
		y == XN[o[
*/
{
	unsigned char *p_gbox = LIB_GBOX_BUF(t->gbox);
	int i, j;

	for (j = 0; j < t->btnsize; j++) {
		for (i = 0; i < t->btnsize; i++)
			p_gbox[(y->py+j)*t->skip + t->px+i] = 8;
	}

	lib_flushgraphbox(0x8001, t->win, t->wpx, t->wpy+y->py,
		t->btnsize, t->btnsize, t->skip-t->sx, p_gbox + y->py*t->skip+t->px);

	return;
}

void scroll_flush(struct SCROLLBAR *b)
/*
	: XN[o[flush
			scroll.ĉ݂Ŏgp
	:
		b == flushXN[o[
*/

{
	unsigned char *p_gbox = LIB_GBOX_BUF(b->gbox);
	lib_flushgraphbox(0x8001, b->win, b->wpx, b->wpy, b->sx, b->sy, b->skip-b->sx, p_gbox + b->py*b->skip+b->px);
	return;
}
